VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Parachute Designer"
   ClientHeight    =   4560
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2910
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4560
   ScaleWidth      =   2910
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cboAlgorithm 
      Height          =   315
      ItemData        =   "Main.frx":0442
      Left            =   960
      List            =   "Main.frx":044C
      Style           =   2  'Dropdown List
      TabIndex        =   19
      Top             =   3000
      Width           =   1815
   End
   Begin VB.CommandButton cmdAbout 
      Caption         =   "&About..."
      Height          =   375
      Left            =   120
      TabIndex        =   17
      Top             =   4080
      Width           =   1215
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "&Close"
      Height          =   375
      Left            =   1560
      TabIndex        =   16
      Top             =   4080
      Width           =   1215
   End
   Begin VB.TextBox txtPrecision 
      Height          =   375
      Left            =   1560
      TabIndex        =   14
      Text            =   "3"
      Top             =   2520
      Width           =   735
   End
   Begin VB.TextBox txtPoints 
      Height          =   375
      Left            =   1560
      TabIndex        =   13
      Text            =   "10"
      Top             =   2040
      Width           =   735
   End
   Begin VB.TextBox txtOverhang 
      Height          =   375
      Left            =   1560
      TabIndex        =   10
      Text            =   "10"
      Top             =   1080
      Width           =   735
   End
   Begin VB.CommandButton cmdGenerate 
      Caption         =   "&Generate"
      Height          =   375
      Left            =   120
      TabIndex        =   8
      Top             =   3600
      Width           =   2655
   End
   Begin VB.TextBox txtPanels 
      Height          =   375
      Left            =   1560
      TabIndex        =   7
      Text            =   "8"
      Top             =   1560
      Width           =   735
   End
   Begin VB.TextBox txtHeight 
      Height          =   375
      Left            =   1560
      TabIndex        =   1
      Text            =   "50"
      Top             =   600
      Width           =   735
   End
   Begin VB.TextBox txtDiameter 
      Height          =   375
      Left            =   1560
      TabIndex        =   0
      Text            =   "100"
      Top             =   120
      Width           =   735
   End
   Begin VB.Label lblAlgorithm 
      Caption         =   "Algorithm:"
      Height          =   255
      Left            =   120
      TabIndex        =   18
      Top             =   3120
      Width           =   735
   End
   Begin VB.Label lblPrecision 
      Caption         =   "Precision Factor:"
      Height          =   255
      Left            =   120
      TabIndex        =   15
      Top             =   2640
      Width           =   1215
   End
   Begin VB.Label lblPoints 
      Caption         =   "Calculated Points:"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   2160
      Width           =   1335
   End
   Begin VB.Label lblOverhang2 
      Caption         =   "cm"
      Height          =   255
      Left            =   2400
      TabIndex        =   11
      Top             =   1200
      Width           =   375
   End
   Begin VB.Label lblOverhang1 
      Caption         =   "Bottom Overhang:"
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   1200
      Width           =   1335
   End
   Begin VB.Label lblPanels 
      Caption         =   "# of Panels:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1680
      Width           =   975
   End
   Begin VB.Label lblHeight2 
      Caption         =   "cm"
      Height          =   255
      Left            =   2400
      TabIndex        =   5
      Top             =   720
      Width           =   375
   End
   Begin VB.Label lblDiameter2 
      Caption         =   "cm"
      Height          =   255
      Left            =   2400
      TabIndex        =   4
      Top             =   240
      Width           =   375
   End
   Begin VB.Label lblHeight1 
      Caption         =   "Height:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   615
   End
   Begin VB.Label lblDiameter1 
      Caption         =   "Diameter:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   240
      Width           =   735
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                           '
'  Bottle Rocket Parachute Designer                                         '
'  Columbus High School Science Olympiad                                    '
'  Copyright (C) 1998-1999 Leo C. Singleton IV                              '
'    WWW: http://www.leosolutions.com/                                      '
'    E-Mail: leo@leosolutions.com                                           '
'                                                                           '
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit
Const PI = 3.14159265358979

Public dPointArrayX
Public dPointArrayY
Public dPanelPointArrayX
Public dPanelPointArrayY
Public nPoints As Integer
Public dDiameter As Double
Public dHeight As Double
Public dOverhang As Double
Public nPanels As Integer
Public dPrecisionFactor As Double
Public dRadius As Double
Public dPerimeter As Double
Public dPanelWidth As Double
Public dPanelLength As Double
Public dPanelSurfaceArea As Double
Public dOverhangRadius As Double
Public dOverhangAngle As Double
Public dOverhangSurfaceArea As Double
Public dPercentError As Double

Public bCancel As Boolean

Private Function Arcsin(dAngle As Double)
    ' VB does not have an inverse sine function - derive one
    Arcsin = Atn(dAngle / Sqr(-dAngle * dAngle + 1))
End Function

Private Sub cmdAbout_Click()
    frmAbout.Show
End Sub

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub cmdGenerate_Click()
    ' make sure all input values are valid
    If (CheckDiameter() = False) Then Exit Sub
    If (CheckHeight() = False) Then Exit Sub
    If (CheckPanels() = False) Then Exit Sub
    If (CheckOverhang() = False) Then Exit Sub
    If (CheckPoints() = False) Then Exit Sub
    If (CheckPrecision() = False) Then Exit Sub
    
    ' hide old results
    frmResults.Hide
    
    ' generate parachute
    GenerateParachute txtDiameter, txtHeight, txtOverhang, Int(txtPanels), Int(txtPoints)
    
    ' stop if cancel was pressed while in GenerateParachute
    If (bCancel = True) Then
        frmProgress.Hide
        Exit Sub
    End If
    
    ' show results
    frmResults.Show
    frmResults.Redraw
End Sub

Private Function CheckDiameter() As Boolean
    If (txtDiameter > 0) Then
        ' diameter is ok
        CheckDiameter = True
    Else
        ' diameter must be > 0
        MsgBox "The parachute cannot be generated because the diameter must be greater than zero."
        CheckDiameter = False
    End If
End Function

Private Function CheckHeight() As Boolean
    If (txtHeight > 0) Then
        ' height is ok
        CheckHeight = True
    Else
        ' height must be > 0
        MsgBox "The parachute cannot be generated because the height must be greater than zero."
        CheckHeight = False
    End If
End Function

Private Function CheckOverhang() As Boolean
Dim dNewPanelWidth As Double
    ' calculate panel width
    dNewPanelWidth = (PI * txtDiameter) / txtPanels
    
    ' check overhang
    If ((txtOverhang * 2) > dNewPanelWidth) Then
        ' too much overhang
        MsgBox "The parachute cannot be generated because the overhang is too long.  The overhang must be less than " & _
            Round(dNewPanelWidth / 2, 2) & " cm."
        CheckOverhang = False
    Else
        ' overhang is ok
        CheckOverhang = True
    End If
End Function

Private Function CheckPanels() As Boolean
    If (Int(txtPanels) >= 3) Then
        ' panels are ok
        CheckPanels = True
    Else
        ' must have at least 3 panels
        MsgBox "The parachute cannot be generated because there must be at least three panels."
        CheckPanels = False
    End If
End Function

Private Function CheckPoints() As Boolean
    If (Int(txtPoints) >= 3) Then
        ' points are ok
        CheckPoints = True
    Else
        ' must calculate at least 3 points
        MsgBox "The parachute cannot be generated because at least three points must be calculated."
        CheckPoints = False
    End If
End Function

Private Function CheckPrecision() As Boolean
    If (CDbl(txtPrecision) >= 0 And CDbl(txtPrecision) <= 10) Then
        ' points are ok
        CheckPrecision = True
    Else
        ' valid precision factors range from 0.0 to 10.0
        MsgBox "The parachute cannot be generated because the precision factor is not valid.  Valid precision factors range from 0.0 to 10.0."
        CheckPrecision = False
    End If
End Function

Private Sub CalculateOverhang()
    ' these formulas have been calculated using simple trig.
    dOverhangRadius = (((dPanelWidth ^ 2) / (4 * dOverhang)) + dOverhang) / 2
    dOverhangAngle = 2 * Arcsin(dPanelWidth / (2 * dOverhangRadius))
End Sub

Private Sub CalculateOverhangSurfaceArea()
    ' this is a complex formula calculated using simple geometry
    dOverhangSurfaceArea = ((dOverhangAngle * (dOverhangRadius ^ 2)) - (dPanelWidth * (dOverhangRadius - dOverhang))) / 2
End Sub

Private Sub CalculatePanelSurfaceArea()
Dim nCurPoint As Integer
Dim dArea As Double
    ' reset surface area
    dPanelSurfaceArea = 0
    
    ' add area of each trapezoid formed by panel points
    For nCurPoint = 1 To (nPoints - 1)
        dArea = (dPanelPointArrayX(nCurPoint) + dPanelPointArrayX(nCurPoint - 1)) * (dPanelLength / (nPoints - 1))
        dPanelSurfaceArea = dPanelSurfaceArea + dArea
    Next
End Sub

Private Sub ConvertSideToPanel(ByVal nPoint As Integer, ByVal dSideX As Double, ByVal dSideY As Double, ByRef dPanelX As Double, ByRef dPanelY As Double)
    ' converts point on side view to point on panel layout
    dPanelY = (frmMain.dPanelLength * nPoint) / (frmMain.nPoints - 1)
    dPanelX = (PI * dSideX) / frmMain.nPanels
End Sub

Private Sub GenerateParachute(dNewDiameter As Double, dNewHeight As Double, dNewOverhang As Double, nNewPanels As Integer, nNewPoints As Integer)
Dim dPointDistance As Double
Dim dOldX As Double
Dim dOldY As Double
Dim dPrecision As Double
Dim dAngle As Double
Dim nCurPoint As Long
    ' copy new variables
    dDiameter = dNewDiameter
    dHeight = dNewHeight
    dOverhang = dNewOverhang
    nPanels = nNewPanels
    nPoints = nNewPoints
    
    ' show progress dialog
    bCancel = False
    frmProgress.SetPoints nPoints
    frmProgress.Show
    
    ' allocate memory to hold calculated points
    ReDim dPointArrayX(0 To (nPoints - 1)) As Double
    ReDim dPointArrayY(0 To (nPoints - 1)) As Double
    
    ReDim dPanelPointArrayX(0 To (nPoints - 1)) As Double
    ReDim dPanelPointArrayY(0 To (nPoints - 1)) As Double
    
    ' calculate radius, perimeter, and panel widths
    dRadius = dDiameter / 2
    dPerimeter = PI * dDiameter
    dPanelWidth = dPerimeter / nPanels
    
    ' ESTIMATE panel lengths
    dPanelLength = (PI * ((3 * (dRadius + dHeight)) - Sqr((dRadius + (3 * dHeight)) * ((3 * dRadius) + dHeight)))) / 4
    
    ' calculate precision factor
    dPrecisionFactor = CDbl(txtPrecision)
    dPrecision = 10 ^ (-dPrecisionFactor)
    
    ' calculate first point
    dAngle = 0
    dPointArrayX(0) = dRadius
    dPointArrayY(0) = 0
    dOldX = dRadius
    dOldY = 0
    
    If cboAlgorithm.ListIndex = 0 Then
    
    ' estimate middle points (this algorithm may be a little rough, but it should get it accurate enough)
    For nCurPoint = 1 To (nPoints - 1)
        ' reset distance to the previous point
        dPointDistance = 0

        ' move along graph until a specific distance from the previous point
        Do While (dPointDistance < (dPanelLength / (nPoints - 1)))
            ' update progress dialog
            frmProgress.UpdateProgress nCurPoint, (200 * dAngle / PI)
            
            ' increment angle (smaller values will give more accurate results)
            dAngle = dAngle + dPrecision

            ' calculate new distance (Pythagorean Th.)
            dPointDistance = Sqr(((dOldX - (dRadius * Cos(dAngle))) ^ 2) + (((dHeight * Sin(dAngle)) - dOldY) ^ 2))
            
            ' pause to check for cancel button
            DoEvents
            If (bCancel = True) Then Exit Sub
        Loop
        
        ' set new points
        dPointArrayX(nCurPoint) = dRadius * Cos(dAngle)
        dPointArrayY(nCurPoint) = dHeight * Sin(dAngle)
        
        dOldX = dPointArrayX(nCurPoint)
        dOldY = dPointArrayY(nCurPoint)
    Next
    
    dPercentError = ((Abs(dOldX) / dRadius) + (Abs(dOldY - dHeight) / dHeight)) * 50
    
    Else
        ' new algorithm
        Dim nCalcPoints As Long, dPointDist As Double
        Dim nRealPoint As Long, nNextPoint As Long
        nRealPoint = Int(10 ^ dPrecisionFactor)
        nCalcPoints = (nPoints - 1) * nRealPoint
        dPointDist = dPanelLength / nCalcPoints
        nNextPoint = 1
        
        dOldX = 0
        dOldY = dHeight
        
        For nCurPoint = 1 To nCalcPoints
            ' update progress dialog
            frmProgress.UpdateProgress nNextPoint, nCurPoint * 100 / nCalcPoints
            
            ' a really long formula - see notebook
            On Error Resume Next
            dOldX = (dPointDist / Sqr(((dHeight * dOldX) / (dRadius ^ 2 * Sqr(1 - ((dOldX ^ 2) / (dRadius ^ 2))))) ^ 2 + 1)) + dOldX
            
            If nCurPoint Mod nRealPoint = 0 Then
                ' this point actually counts
                ' note: we are generating in the opposite order that they are stored
                dPointArrayX(nPoints - nNextPoint - 1) = dOldX
                dPointArrayY(nPoints - nNextPoint - 1) = dHeight * Sqr(1 - ((dOldX ^ 2) / (dRadius ^ 2)))
                nNextPoint = nNextPoint + 1
            End If
        
            ' pause to check for cancel button
            DoEvents
            If (bCancel = True) Then Exit Sub
        Next
        
        dPercentError = Abs(dOldX - dRadius) * 100 / dRadius
    End If
    
    ' calculate last point
    dPointArrayX(nPoints - 1) = 0
    dPointArrayY(nPoints - 1) = dHeight
    
    ' generate panel points
    For nCurPoint = 0 To (nPoints - 1)
        ConvertSideToPanel nCurPoint, dPointArrayX(nCurPoint), dPointArrayY(nCurPoint), dOldX, dOldY
        dPanelPointArrayX(nCurPoint) = dOldX
        dPanelPointArrayY(nCurPoint) = dOldY
        
        ' check for cancel
        DoEvents
        If (bCancel = True) Then Exit Sub
    Next
    
    ' calculate overhangs
    If (dOverhang > 0) Then
        CalculateOverhang
        CalculateOverhangSurfaceArea
    Else
        dOverhangRadius = 0
        dOverhangAngle = 0
        dOverhangSurfaceArea = 0
    End If
    
    ' calculate panel surface area
    CalculatePanelSurfaceArea
    
    ' hide progress dialog
    frmProgress.Hide
End Sub

Private Sub Form_Load()
    cboAlgorithm.ListIndex = 1
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' this is the main form - exit
    End
End Sub
